unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs,
  VCLTee.Chart;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    a_Edit: TLabeledEdit;
    C_Edit: TLabeledEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TPointSeries;
    Button1: TButton;
    Series3: TLineSeries;
    Label1: TLabel;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    Series4: TPointSeries;
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    function datainput: boolean;
    procedure Drawing(yyt, yyb: double);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses
  system.Math;

var
  C : double;       // Jei[
  a : double;       // ̌X
  b : double;       // ̐ؕ
  xs, xe: double;   // X͈̔
  yt, yb: double;   // y͈̔


// ͏
function TForm1.datainput: boolean;
var
  ch: integer;
begin
  result := false;
  C := 0;
  val(C_edit.Text, C, ch);
  if (ch <> 0) or (C <= 0) then begin
    application.MessageBox('Jei[ɊԈႢ܂B','',0);
    exit;
  end;
  val(a_edit.Text, a, ch);
  if ch <> 0 then begin
    application.MessageBox('̌XɊԈႢ܂B','',0);
    exit;
  end;
  result := true;
end;

// }
// Ⴂ̎xʒu
procedure TForm1.Drawing(yyt, yyb: double);
const
  K = 500;
var
  xn  : double;
  x, dx : double;
  y   : double;
  i   : integer;
begin
  dx := (xe - xs) / K;
  // }
  for i := -10 to K + 10 do begin
    xn := i * dx + xs;                // vZʒu
    x := abs(xn);                     // őo݈ʒű
    y := C * (cosh(x / C) - 1);       // Jei[ y
    if (y < yyt) and (y >= yyb) then Series1.AddXY(xn, y);
    y := a * xn + b;                  // 
    if (y < yyt) and (y >= yyb) then Series3.AddXY(xn, y);
  end;
end;

// Jei[ƒ̐ڐvZ̎s
procedure TForm1.Button1Click(Sender: TObject);
var
  fd: double;
  x : double;
  ys, yc : double;
  xxs, xxe : double;
  yyb, yyt : double;
begin
  xs := -1;
  xe :=  1;
  if not datainput then exit;
  memo1.Clear;
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  Series4.Clear;
  // XãJei[ȐxW
  x := arcsinh(a) * C;
//  x := ln(a + sqrt(a * a + 1)) * C;
  xs := x;
  yc := C * (cosh(x / C) - 1);
  memo1.Lines.Add('ړ_W');
  memo1.Lines.Add('@@X= ' + floatTostr(xs));
  memo1.Lines.Add('@@Y= ' + floatTostr(yc));

  b := yc - a * x;                                // ؕ
  ys := a * x + b;                                // yl
  memo1.Lines.Add('̐ؕ b= ' + floatTostr(b));
  xxe := sinh(x / C);
  memo1.Lines.Add('Jei[ړ_ʒuX = ' + floatTostr(xxe));
  // OtXP[ݒ
  if xs < 0 then xe := -xs
            else begin
              xe := xs;
              xs := -xs;
            end;
  if a > 0 then begin
    if C > 1 then xs := xs - sqrt(C)
             else xs := xs - C;
    xe := xe + C;
  end
  else begin
    xs := xs - C;
    if C > 1 then xe := xe + sqrt(C)
             else xe := xe + C;
  end;

  xxs := xs;
  xxe := xe;
  yb := 0;
  if a > 0 then yyb := (a * xs + b) / 10
           else yyb := (a * xe + b) / 10;
  if -yyb > C then yyb := -C;
  yt := yc;
  yyt := yc;
  if xe - xs > yt then begin
    fd := ((xe - xs) - yt) / 2;
    yyb := yb - fd;
    yyt := yt + fd;
  end
  else begin
    fd := (yt - (xe - xs)) / 2;
    xxs := xs - fd;
    xxe := xe + fd;
  end;
  fd := (xxe - xxs) / 10;         // Ot]T
  xxs := xxs - fd;
  xxe := xxe + fd;
  yyb := yyb - fd;
  yyt := yyt + fd;
  if checkbox1.Checked then begin
    Series2.AddXY(xxs, yyt);
    Series2.AddXY(xxs, yyb);
    Series2.AddXY(xxe, yyb);
    application.ProcessMessages;
  end;
  Drawing(yyt, yyb);              // Ot
  Series4.AddXY(x, ys);           // _ 
end;

end.
